<?php
class feedoComponents extends sfComponents
{
	public function executePartialMenu1()
	{
		if($this->getUser()->isAuthenticated())
		{
			$this->welcome = $this->getContext()->getI18N()->__("Welcome %1%", 
							array('%1%'=>$this->getUser()->getAttribute('correo')));
			$this->menu = array($this->getContext()->getI18N()->__("Logout")
						,$this->getContext()->getI18N()->__("Change password"));
			$this->enlaces = array("feedo/cerrarSesion", "feedo/formularioCambiarContrasenia");
		}
		else
		{
			$this->welcome = $this->getContext()->getI18N()->__("You aren't logged");
			$this->menu = array($this->getContext()->getI18N()->__("Sign in")
						,$this->getContext()->getI18N()->__("Create account"));
			$this->enlaces = array("feedo/formularioIniciarSesion", "feedo/formularioCrearCuenta");
		}
	}
	
	public function executePartialInicio()
	{//obtenemos categorias del sistema y el usuario para mostrarle un men al usuario
		$c = new Criteria();
		$c->addJoin(CategoriasPeer::ID_CATEGORIA, CatAdminUsuarioPeer::ID_CATEGORIA);
		$c->add(CatAdminUsuarioPeer::ID_USUARIO, $this->getUser()->getAttribute('id_user'));
		$categorias = CategoriasPeer::doSelect($c);
		foreach($categorias as $value)//creamos un vector al que accederemos en el template para obtener las categorias
		{
			$aux[$value->getIdCategoria()] = $value->getDescripcion();
		}
		$this->cat = $aux;	
	}
}