<?php

/**
 * 
 * Subclase que representa una fila de la tabla 'usuarios'.
 * 
 *
 * @package lib.model
 */ 
class Usuarios extends BaseUsuarios
{
/**
 * 
 * Retorna la cadena de texto 'S&iacute;' si el usuario es un administrador del sistema. 
 * En caso contrario retorna la cadena 'No'.
 * @return string
 *  
 */
	public function getEstadoAdmin()
	{
		if($this->getAdministrador() == 1)
			return 'S&iacute;';
		else
			return 'No';
	}
/**
 * 
 * Marca en la base de datos al usuario como administrador del sistema.
 * 
 */	
	public function setAdmin()
	{
		$par = sfContext::getInstance()->getRequest()->getParameter('usuarios[admin]');
		if($par == 'Si')
			$this->setAdministrador(1);
		if($par == 'No')
			$this->setAdministrador(0);
	}
}
