-- phpMyAdmin SQL Dump
-- version 2.11.4
-- http://www.phpmyadmin.net
--
-- Servidor: localhost
-- Tiempo de generación: 14-05-2008 a las 12:24:18
-- Versión del servidor: 5.0.51
-- Versión de PHP: 5.2.5

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";

--
-- Base de datos: `feedo`
--

DROP DATABASE IF EXISTS `feedo`;
CREATE DATABASE `feedo`;
USE `feedo`;

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `categorias`
--

CREATE TABLE IF NOT EXISTS `categorias` (
  `Id_Categoria` int(10) unsigned NOT NULL auto_increment,
  `Descripcion` varchar(100) NOT NULL,
  `Sistema` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`Id_Categoria`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=45 ;

--
-- Volcar la base de datos para la tabla `categorias`
--

INSERT INTO `categorias` (`Id_Categoria`, `Descripcion`, `Sistema`) VALUES
(2, 'Noticias', 1),
(3, 'General', 1),
(4, 'Otros', 1),
(5, 'Blogs', 1),
(6, 'Meteorologia', 1),
(7, 'Tecnologia', 1);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `cat_admin_usuario`
--

CREATE TABLE IF NOT EXISTS `cat_admin_usuario` (
  `Id_Categoria` int(10) unsigned NOT NULL,
  `Id_Usuario` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`Id_Categoria`,`Id_Usuario`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

--
-- Volcar la base de datos para la tabla `cat_admin_usuario`
--

INSERT INTO `cat_admin_usuario` (`Id_Categoria`, `Id_Usuario`) VALUES
(2, 1),
(2, 3),
(3, 1),
(3, 3),
(4, 1),
(4, 3),
(5, 1),
(5, 3),
(6, 1),
(6, 3),
(7, 1),
(7, 3);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `conf_feed`
--

CREATE TABLE IF NOT EXISTS `conf_feed` (
  `Id_Conf_Feed` int(10) unsigned NOT NULL auto_increment COMMENT 'Indice de la tabla',
  `Voz` tinyint(3) unsigned NOT NULL COMMENT 'Indica el tipo de voz a aplicar en la lectura de los feeds',
  `Velocidad_Lectura` tinyint(3) unsigned NOT NULL COMMENT 'Indica la velocidad de lectura a aplicar',
  `Numero_Entradas` tinyint(3) unsigned NOT NULL COMMENT 'Indica el numero de entradas a mostrar en los feeds',
  PRIMARY KEY  (`Id_Conf_Feed`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='Almacena las configuraciones de los feeds' AUTO_INCREMENT=57 ;

--
-- Volcar la base de datos para la tabla `conf_feed`
--

INSERT INTO `conf_feed` (`Id_Conf_Feed`, `Voz`, `Velocidad_Lectura`, `Numero_Entradas`) VALUES
(56, 1, 1, 6);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `feeds`
--

CREATE TABLE IF NOT EXISTS `feeds` (
  `Id_Feed` int(10) unsigned NOT NULL auto_increment COMMENT 'Indice de la tabla',
  `URL` varchar(200) NOT NULL COMMENT 'Direccion URL del feed',
  `Recomendado` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`Id_Feed`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='Almacena los feeds introducidos en el sistema' AUTO_INCREMENT=47 ;

--
-- Volcar la base de datos para la tabla `feeds`
--

INSERT INTO `feeds` (`Id_Feed`, `URL`, `Recomendado`) VALUES
(28, 'http://tirsoweb.freehostia.com/feed/', 1),
(29, 'http://feeds.feedburner.com/meneame/published', 1),
(30, 'http://www.joystiq.com/rss.xml', 1),
(31, 'http://www.kotaku.com/excerpts.xml', 1),
(32, 'http://feeds.gawker.com/kotaku/excerpts.xml', 1),
(34, 'http://www.anaitgames.com/?feed=rss2', 1),
(35, 'http://xataka.com/index.xml', 1),
(36, 'http://curiosoperoinutil.com/feed/', 1),
(37, 'http://feeds.feedburner.com/Malaprensa', 1),
(38, 'http://www.nytimes.com/services/xml/rss/nyt/HomePage.xml', 1),
(39, 'http://tirsoweb.awardspace.com/feed/', 1),
(40, 'http://www.elpais.com/rss.html', 1),
(41, 'http://www.rssweather.com/icao/LEBL/rss.php', 1),
(42, 'http://www.rssweather.com/icao/LEVS/rss.php', 1),
(45, 'http://www.lne.es/rss/rss.html', 1);

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `feeds_sistema`
--

CREATE TABLE IF NOT EXISTS `feeds_sistema` (
  `usuarios_id` int(10) unsigned NOT NULL COMMENT 'Indice del usuario al que pertenece el feed',
  `categorias_id` int(10) unsigned NOT NULL COMMENT 'Indice de la categoria a la que pertenece el feed',
  `conf_feed_id` int(10) unsigned NOT NULL COMMENT 'Indice de la configuracion del feed',
  `feeds_id` int(10) unsigned NOT NULL COMMENT 'Indice del feed',
  PRIMARY KEY  (`usuarios_id`,`categorias_id`,`feeds_id`),
  KEY `categorias_id` (`categorias_id`),
  KEY `feeds_id` (`feeds_id`),
  KEY `conf_feed_id` (`conf_feed_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='Feeds de los usuarios y su categoria y configuracion';

--
-- Volcar la base de datos para la tabla `feeds_sistema`
--


-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `url_visitadas`
--

CREATE TABLE IF NOT EXISTS `url_visitadas` (
  `Id_Url` int(10) unsigned NOT NULL auto_increment,
  `Url` varchar(200) NOT NULL,
  PRIMARY KEY  (`Id_Url`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

--
-- Volcar la base de datos para la tabla `url_visitadas`
--


-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `url_visitadas_usuario`
--

CREATE TABLE IF NOT EXISTS `url_visitadas_usuario` (
  `Id_Url` int(10) unsigned NOT NULL,
  `Id_Usuario` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`Id_Url`,`Id_Usuario`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

--
-- Volcar la base de datos para la tabla `url_visitadas_usuario`
--


-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `usuarios`
--

CREATE TABLE IF NOT EXISTS `usuarios` (
  `Id_Usuario` int(10) unsigned NOT NULL auto_increment COMMENT 'Indice de la tabla',
  `Id_Conf_Feed` int(10) unsigned NOT NULL COMMENT 'Indice de la configuracion por defecto para el usuario',
  `Password` char(44) NOT NULL COMMENT 'Password del usuario',
  `Mail` varchar(30) NOT NULL COMMENT 'Direccion de correo del usuario',
  `Administrador` tinyint(1) NOT NULL default '0' COMMENT 'Indica si el usuario es administrador o no',
  `Id_Sesion` int(10) NOT NULL COMMENT 'Identificador de sesion, utilizado para recordar contraseÃ±a',
  `Salt` varchar(4) NOT NULL COMMENT 'Utilizado para aplicar hashing a las contraseÃ±as',
  `Cultura` varchar(5) NOT NULL,
  PRIMARY KEY  (`Id_Usuario`),
  UNIQUE KEY `Mail` (`Mail`),
  KEY `FK_usuarios_1` (`Id_Conf_Feed`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC COMMENT='Almacena los datos de los usuarios' AUTO_INCREMENT=5 ;

--
-- Volcar la base de datos para la tabla `usuarios`
--

INSERT INTO `usuarios` (`Id_Usuario`, `Id_Conf_Feed`, `Password`, `Mail`, `Administrador`, `Id_Sesion`, `Salt`, `Cultura`) VALUES
(1, 56, '3408b5e1dbf23ffeeb0fad4e813bc0165a030e8f7d38', 'admin@midominio.com', 1, 0, '3408', 'es_ES'),
(3, 56, '1f933a82a96717a0bf7907a212b9a499b72cb67d7322', 'invitado@midominio.com', 0, 0, '1f93', 'es_ES');
