<?php



class CategoriasMapBuilder {

	
	const CLASS_NAME = 'lib.model.map.CategoriasMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap('propel');

		$tMap = $this->dbMap->addTable('categorias');
		$tMap->setPhpName('Categorias');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID_CATEGORIA', 'IdCategoria', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('DESCRIPCION', 'Descripcion', 'string', CreoleTypes::VARCHAR, true, 100);

		$tMap->addColumn('SISTEMA', 'Sistema', 'int', CreoleTypes::TINYINT, true, null);

	} 
} 