<?php



class UrlVisitadasUsuarioMapBuilder {

	
	const CLASS_NAME = 'lib.model.map.UrlVisitadasUsuarioMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap('propel');

		$tMap = $this->dbMap->addTable('url_visitadas_usuario');
		$tMap->setPhpName('UrlVisitadasUsuario');

		$tMap->setUseIdGenerator(false);

		$tMap->addPrimaryKey('ID_URL', 'IdUrl', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addPrimaryKey('ID_USUARIO', 'IdUsuario', 'int', CreoleTypes::INTEGER, true, null);

	} 
} 