<?php



class UsuariosMapBuilder {

	
	const CLASS_NAME = 'lib.model.map.UsuariosMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap('propel');

		$tMap = $this->dbMap->addTable('usuarios');
		$tMap->setPhpName('Usuarios');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID_USUARIO', 'IdUsuario', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('ID_CONF_FEED', 'IdConfFeed', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('PASSWORD', 'Password', 'string', CreoleTypes::CHAR, true, 44);

		$tMap->addColumn('MAIL', 'Mail', 'string', CreoleTypes::VARCHAR, true, 30);

		$tMap->addColumn('ADMINISTRADOR', 'Administrador', 'int', CreoleTypes::TINYINT, true, null);

		$tMap->addColumn('ID_SESION', 'IdSesion', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('SALT', 'Salt', 'string', CreoleTypes::VARCHAR, true, 4);

		$tMap->addColumn('CULTURA', 'Cultura', 'string', CreoleTypes::VARCHAR, true, 5);

	} 
} 